<?php

if(!defined('IN_PHPBB'))
  exit;

if(file_exists($phpbb_root_path . 'bowob/bowob_core.' . $phpEx))
  include($phpbb_root_path . 'bowob/bowob_core.' . $phpEx);

function bowobs_header()
{
  global $template, $phpEx, $phpbb_root_path;
  
  $template->assign_var('L_BOWOB', 'Chat');
  $template->assign_var('U_BOWOB', append_sid("{$phpbb_root_path}bowob." . $phpEx));
  $template->assign_var('BOWOB_CODE', bowobf_multi_show());
}

function bowobs_version()
{
  return '1_3';
}

function bowobs_user_logued()
{
  global $user;
  
  if($user->data['is_registered'])
    return true;
  else
    return false;
}

function bowobs_user_id()
{
  global $user;
  
  return $user->data['user_id'];
}

function bowobs_user_name()
{
  global $user;

  if($user->data['is_registered'])
    return $user->data['username'];
  else
    return '';
}

function bowobs_user_validate($username)
{
  global $config;
  
  $vals = validate_string($username, false, $config['min_name_chars'], $config['max_name_chars']);
  $valu = validate_username($username, '');
  
  if($vals == 'TOO_SHORT')
    return 1;
  elseif($vals == 'TOO_LONG')
    return 2;
  elseif($valu == 'INVALID_CHARS')
    return 3;
  elseif($valu == 'USERNAME_TAKEN')
    return 4;
  elseif($valu == 'USERNAME_DISALLOWED')
    return 5;
  
  return 0;
}

function bowobs_user_logued_validate()
{
  return true;
}

function bowobs_redirect_index()
{
  global $phpEx, $phpbb_root_path;
  
  redirect(append_sid("{$phpbb_root_path}index." . $phpEx));
  exit();
}

function bowobs_redirect_login()
{
  global $phpEx, $phpbb_root_path;
  
  redirect(append_sid("{$phpbb_root_path}ucp." . $phpEx, 'mode=login'));
  exit();
}

function bowobs_enable(){}

function bowobs_disable(){}

function bowobs_db_insert($sync, $time, $user, $type)
{
  global $db, $table_prefix;
  
  $sql = 'INSERT INTO ' . $table_prefix . 'bowob ' . $db->sql_build_array('INSERT', array(
    'sync' => (string)$sync,
    'time' => (int)$time,
    'user' => utf8_normalize_nfc($user),
    'type' => (int)$type,
  ));
  $db->sql_query($sql);
  
  return $db->sql_nextid();
}

function bowobs_db_extract($sid, $ssync, $stime)
{
  global $db, $table_prefix;
  
  $db->sql_query('DELETE FROM ' . $table_prefix . 'bowob WHERE time < ' . (int)$stime);
  
  $sql = 'SELECT sync, user, type FROM ' . $table_prefix . 'bowob WHERE ' . $db->sql_build_array('SELECT', array(
    'id' => (int)$sid,
    'sync' => (string)$ssync,
  ));
  $result = $db->sql_query($sql);
  $row = $db->sql_fetchrow($result);
  
  if(!$row || $row['sync'] != $ssync)
  {
    return array();
  }
  else
  {
    $db->sql_query('DELETE FROM ' . $table_prefix . 'bowob WHERE id = ' . (int)$sid);
    
    return array($row['user'], $row['type'], '');
  }
}

function bowobs_form_blocklink()
{
  return '';
}

function bowobs_form_blocklogin()
{
  return '';
}

function bowobs_form_login()
{
  global $template, $phpEx, $phpbb_root_path, $user;

  $err = '';
  $step = request_var('bowob_step', '');
  if($step != '')
  {
    if($step == '2')
      $err = 'TOO_SHORT';
    elseif($step == '3')
      $err = 'TOO_LONG';
    elseif($step == '4')
      $err = 'INVALID_CHARS_USERNAME';
    elseif($step == '5')
      $err = 'USERNAME_TAKEN_USERNAME';
    elseif($step == '6')
      $err = 'USERNAME_DISALLOWED_USERNAME';
  }
  
  
  $template->assign_vars(array(
    'S_BOWOB_ACTION' => append_sid("{$phpbb_root_path}bowob." . $phpEx, 'bowob_step=1'),
    'BOWOB_ERROR' => ($err == '' ? '' : $user->lang[$err]),
  ));
  
  page_header('Chat', false);
  $template->set_filenames(array('body' => 'bowob_body.html'));
  page_footer();
}

function bowobs_form_error($type, $username)
{
  global $phpEx, $phpbb_root_path;
  
  if($type == 1)
    redirect(append_sid("{$phpbb_root_path}bowob." . $phpEx, 'bowob_step=2'));
  if($type == 2)
    redirect(append_sid("{$phpbb_root_path}bowob." . $phpEx, 'bowob_step=3'));
  if($type == 3)
    redirect(append_sid("{$phpbb_root_path}bowob." . $phpEx, 'bowob_step=4'));
  if($type == 4)
    redirect(append_sid("{$phpbb_root_path}bowob." . $phpEx, 'bowob_step=5'));
  if($type == 5)
    redirect(append_sid("{$phpbb_root_path}bowob." . $phpEx, 'bowob_step=6'));
  exit();
}

function bowobs_cookie_get($value)
{
  if(get_magic_quotes_gpc()){
    return stripslashes($value);
  }
  else{
    return $value;
  }
}

function bowobs_get_cookie($name, $default)
{
  $data = request_var($name, $default, true, true);
  
  if(get_magic_quotes_gpc()){
    return stripslashes($data);
  }
  else{
    return $data;
  }
}

?>
